local e=(require"luci.model.uci").cursor()
local a,t,e
a=Map("dockerd",
translate("Docker - Configuration"),
translate("DockerMan is a simple docker manager client for LuCI"))
if nixio.fs.access("/usr/bin/dockerd")and not a.uci:get_bool("dockerd","dockerman","remote_endpoint")then
t=a:section(NamedSection,"globals","section",translate("Docker Daemon settings"))
e=t:option(Flag,"auto_start",translate("Auto start"))
e.rmempty=false
e.write=function(o,o,t)
if t=="1"then
luci.util.exec("/etc/init.d/dockerd enable")
else
luci.util.exec("/etc/init.d/dockerd disable")
end
a.uci:set("dockerd","globals","auto_start",t)
end
e=t:option(Value,"data_root",
translate("Docker Root Dir"))
e.placeholder="/opt/docker/"
e:depends("remote_endpoint",0)
e=t:option(Value,"bip",
translate("Default bridge"),
translate("Configure the default bridge network"))
e.placeholder="172.17.0.1/16"
e.datatype="ipaddr"
e:depends("remote_endpoint",0)
e=t:option(DynamicList,"registry_mirrors",
translate("Registry Mirrors"),
translate("It replaces the daemon registry mirrors with a new set of registry mirrors"))
e:value("https://hub-mirror.c.163.com","https://hub-mirror.c.163.com")
e:depends("remote_endpoint",0)
e.forcewrite=true
e=t:option(ListValue,"log_level",
translate("Log Level"),
translate('Set the logging level'))
e:value("debug",translate("Debug"))
e:value("",translate("Info"))
e:value("warn",translate("Warning"))
e:value("error",translate("Error"))
e:value("fatal",translate("Fatal"))
e.rmempty=true
e:depends("remote_endpoint",0)
e=t:option(DynamicList,"hosts",
translate("Client connection"),
translate('Specifies where the Docker daemon will listen for client connections (default: unix:///var/run/docker.sock)'))
e:value("unix:///var/run/docker.sock","unix:///var/run/docker.sock")
e:value("tcp://0.0.0.0:2375","tcp://0.0.0.0:2375")
e.rmempty=true
e:depends("remote_endpoint",0)
end
t=a:section(NamedSection,"dockerman","section",translate("DockerMan settings"))
t:tab("ac",translate("Access Control"))
t:tab("dockerman",translate("DockerMan"))
e=t:taboption("dockerman",Flag,"remote_endpoint",
translate("Remote Endpoint"),
translate("Connect to remote docker endpoint"))
e.rmempty=false
e.validate=function(t,t,t)
local t=luci.http.formvaluetable("cbid.dockerd")
if t["dockerman.remote_endpoint"]=="1"then
if t["dockerman.remote_port"]and t["dockerman.remote_port"]~=""and t["dockerman.remote_host"]and t["dockerman.remote_host"]~=""then
return 1
else
return nil,translate("Please input the PORT or HOST IP of remote docker instance!")
end
else
if not t["dockerman.socket_path"]then
return nil,translate("Please input the SOCKET PATH of docker daemon!")
end
end
return 0
end
e=t:taboption("dockerman",Value,"socket_path",
translate("Docker Socket Path"))
e.default="/var/run/docker.sock"
e.placeholder="/var/run/docker.sock"
e:depends("remote_endpoint",0)
e=t:taboption("dockerman",Value,"remote_host",
translate("Remote Host"),
translate("Host or IP Address for the connection to a remote docker instance"))
e.datatype="host"
e.placeholder="10.1.1.2"
e:depends("remote_endpoint",1)
e=t:taboption("dockerman",Value,"remote_port",
translate("Remote Port"))
e.placeholder="2375"
e.datatype="port"
e:depends("remote_endpoint",1)
if nixio.fs.access("/usr/bin/dockerd")and not a.uci:get_bool("dockerd","dockerman","remote_endpoint")then
e=t:taboption("ac",DynamicList,"ac_allowed_interface",translate("Allowed access interfaces"),translate("Which interface(s) can access containers under the bridge network, fill-in Interface Name"))
local a=luci.sys and luci.sys.net and luci.sys.net.devices()or{}
for a,t in ipairs(a)do
e:value(t,t)
end
e=t:taboption("ac",DynamicList,"ac_allowed_ports",translate("Ports allowed to be accessed"),translate("Which Port(s) can be accessed, it's not restricted by the Allowed Access interfaces configuration. Use this configuration with caution!"))
e.placeholder="8080/tcp"
local i=require"luci.model.docker"
local a,t,o
local i=i.new()
if i:_ping().code~=200 then
o=true
else
o=false
t=i.containers:list()
if t and t.code and t.code<300 then
a=t.body
end
end
if a then
for t,a in ipairs(a)do
if a.State=="running"and a.Ports then
for o,t in ipairs(a.Ports)do
if t.PublicPort and t.IP and not string.find(t.IP,":")then
e:value(t.PublicPort.."/"..t.Type,a.Names[1]:sub(2).." | "..t.PublicPort.." | "..t.Type)
end
end
end
end
end
end
return a
